function excavate(depth, width, height)
    -- Digging loop
    for h = 1, height do
        -- Digging a layer
        for w = 1, width do
            -- Digging a row
            for d = 1, depth-1 do
                turtle.dig() -- Digging forward
                turtle.forward() -- Moving forward
            end
            --move to start of row
            for d = 1, depth-1 do
                turtle.back()
            end
            
            -- go to next row if not last row
            if w<width then
                turtle.turnRight()
                turtle.dig()
                turtle.forward()
                turtle.turnLeft()
            end
        end
        
        --move to start of layer
        turtle.turnRight()
        for w = 1, width do
            turtle.back()
        end
        turtle.turnLeft()
        
        --go to next layer if not last layer
        if h<height then
            turtle.digUp()
            turtle.up()
        end
    end

    --go to start pos
    for h=1, height do
        turtle.down()
    end
end